<?php
/**
 *------------------------------------------------------------------------------
 *  iCagenda v3 by Jooml!C - Events Management Extension for Joomla! 2.5 / 3.x
 *------------------------------------------------------------------------------
 * @package     com_icagenda
 * @copyright   Copyright (c)2012-2013 Cyril Rezé, Jooml!C - All rights reserved
 *
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Cyril Rezé (Lyr!C)
 * @link        http://www.joomlic.com
 *
 * @version     3.1.1 2013-07-28
 * @since       1.0
 *------------------------------------------------------------------------------
*/

// No direct access to this file
defined('_JEXEC') or die();

jimport('joomla.application.component.modelitem');
jimport( 'joomla.html.parameter' );
jimport( 'joomla.registry.registry' );

jimport('joomla.user.helper');
jimport('joomla.access.access');

class iCModelItem extends JModelItem
{

	/**
	 * @var msg
	 */
	protected $msg;
	protected $filters;
	protected $options;
	protected $itObj;
	protected $where;


	/**
	 * Model Builder
	 */
	protected function startiCModel()
	{
		$this->filters = array();
		$this->options = array();
		$this->items = array();
		$this->itObj= new stdClass;
	}


	/**
	 * Table importation
	 */
	public function getTable($type = 'icagenda', $prefix = 'icagendaTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}


	/**
	 * Get all data
	 */
	protected function getItems ($structure)
	{
		// renvoie les éléments

		// ADD is_array 1.2.9
		if (isset($this->items) && is_array($this->items)) { $this->items=$this->getDBitems(); }

		foreach ($structure as $k=>$v)
		{
			$this->itObj->$k=$this->$k($v);
		}
		return $this->itObj;
	}


	/**
	 * Add the filters to be used in queries
	 */
	protected function addFilter($name, $value)
	{
		$this->filters[$name]=$value;
	}


	/**
	 * Add the options you use to obtain the various data in the right setting
	 */
	protected function addOption($name, $value)
	{
		$this->options[$name]=$value;
	}


	/**
	 * Fetch data from DB
	 */
	protected function getDBitems()
	{
		// Preparing connection to db
		$db	= $this->getDbo();

		// Preparing the query
		$query = $db->getQuery(true);

		// Selectable items
		$query->select('next AS tNext, dates AS tDates, period AS tPeriod, id AS tId, state AS tState, access AS tAccess');
		$query->from('`#__icagenda_events` AS e');
//		$query->where((' e.next < (CURDATE()) ') AND (' e.state = 1 '));
		$query->where(' e.state = 1 ');
		$db->setQuery($query);

		$allnext = $db->loadObjectList();

//		$tNext=$db->loadObject()->tNext;
//		$tDates=$db->loadObject()->tDates;
//		$tPeriod=$db->loadObject()->tPeriod;
//		$tId=$db->loadObject()->tId;

//print_r($allnext);

foreach ($allnext as $an) {
		$tNext=$an->tNext;
		$tDates=$an->tDates;
		$tPeriod=$an->tPeriod;
		$tId=$an->tId;

		$dates=unserialize($tDates);
		if (isset($tPeriod)) {
			$period=unserialize($tPeriod);
		} else {
			$period=unserialize($tDates);
		}

		$daysptest = '';
		$daysdtest = $dates[0];

		if (($daysdtest == '0000-00-00 00:00:00') AND ($period != NULL)) {
			$DatesList=$period;
			$alldates=$DatesList;
		}
		if (($daysdtest != '0000-00-00 00:00:00') AND ($period != NULL)) {
			$DatesList=array_merge($dates, $period);
			$alldates=$DatesList;
		}
		if (($daysdtest != '0000-00-00 00:00:00') AND ($period == NULL)) {
			$DatesList=$dates;
			$alldates=$DatesList;
		}

		rsort($alldates);

		$today=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$hour= date('H');
		$min= date('i');
		$today=mktime(0,0,0,$m,$day,$y);

		if ($tNext <= $today) {
			$dd = $this->mkt($alldates[0]);
			foreach($alldates as $a){
				$d=$this->mkt($a);
				if ($dd < $today){
					$tNext=date('Y-m-d H:i', $dd);
				}
				elseif ($d>=$today){
					$tNext=date('Y-m-d H:i', $d);
				}
			}
		}
		$next=$tNext;

		$db		= JFactory::getDBO();
//		$db		= $this->getDbo();
		$query	= $db->getQuery(true);

		$query->update('#__icagenda_events');
		$query->set("`next`='".$next."'");
		$query->where('`id`='.(int)$tId);
		$db->setQuery($query);
		$db->query($query);
}



		// Preparing connection to db
		$db	= $this->getDbo();

		// Preparing the query
		$query = $db->getQuery(true);

		// Selectable items
		$query->select('e.id, e.title, e.alias, e.access, e.language, e.params, e.catid, e.image, e.file, e.displaytime, e.dates, e.period, e.startdate, e.enddate, e.time, e.desc, e.next, e.address, e.city, e.country, e.phone, e.email, e.website, e.place as place_name, e.coordinate as coordinate, e.lat as lat, e.lng as lng');
		$query->select(' l.desc as location_desc');
		$query->select(' c.title as cat_title, c.color as cat_color, c.desc as cat_desc, c.alias as cat_alias');
		//$query->select(' r.id as regId, r.eventid as event_id, r.name as reg_username');

		// join
		$query->from('`#__icagenda_events` AS e');
		$query->leftJoin('`#__icagenda_category` AS c ON c.id = e.catid');
		$query->leftJoin('`#__icagenda_events` AS l ON l.id = e.place');
		//$query->leftJoin('`#__icagenda_location` AS l ON l.id = e.location');
		//$query->leftJoin('`#__icagenda_registration` AS r ON r.eventid = e.id');


		// Where (filters)
		$filters=$this->filters;
		$where='e.state ='.$filters['state'];
		unset($filters['state']);
		foreach($filters as $k=>$v){

			// Access Control
			$public = '1';
			$notset = '0';
			$user = JFactory::getUser();
			$userLevels = $user->getAuthorisedViewLevels();
		if(version_compare(JVERSION, '3.0', 'lt')) {
			$userGroups = $user->getAuthorisedGroups();
		} else {
			$userGroups = $user->groups;
		}
			//print_r($userGroups);
			//print_r($userLevels);

//			foreach ($userGroups as $group){
//				if ($group != '8') {
if ( !in_array('8', $userGroups) )  {
					$where.=' AND (e.access LIKE \'%'.$public.'%\' ';

					foreach ($allnext as $an) {
						$tAccess=$an->tAccess;
						$control='';

						//$access=JRequest::getInt('access');
						//echo '['.$tAccess.']';
						//if ($tAccess == '0') { $tAccess='1'; }
						//echo $tAccess.'/';

						foreach ($userLevels as $level){
							if ($level == $tAccess) {
								$control=$tAccess;
								// in the case of access
								$where.=' OR e.access LIKE \'%'.$control.'%\' ';
								$where.=' OR e.access LIKE \'%'.$notset.'%\' ';
							}
						}
					}

					$where.=' ) ';
}
//				}
//			}


			// Language Control
			$lang = JFactory::getLanguage();
			$eventLang = '';
			$langTag = '';
			$langTag = $lang->getTag();
			$eventLang=$langTag;
			$langall="*";

			// in the case of language
			$where.=' AND (e.language LIKE "%'.$eventLang.'%" OR ';
			$where.=' e.language LIKE \'%'.$langall.'%\')';



			// normal cases
			if ($k!='key' && $k!='next' && $k!='e.catid' && $k!='id'){
				$where.=' AND '.$k.' LIKE "%'.$v.'%"';
			}

			// in case of search
			if ($k=='key'){
				$keys=explode(' ', $v);
				foreach ($keys as $ke){
					$where.=' AND (e.title LIKE \'%'.$ke.'%\' OR ';
					$where.=' e.desc LIKE \'%'.$ke.'%\' OR ';
					$where.=' e.address LIKE \'%'.$ke.'%\' OR ';
					$where.=' e.place LIKE \'%'.$ke.'%\' OR ';
					$where.=' c.title LIKE \'%'.$ke.'%\')';
				}
			}

			// in the case of time
			if ($k=='next'){
				if($v==1) $where.=' AND e.next >= (CURDATE())';
				if($v==2) $where.=' AND e.next < (CURDATE())';
			}


			// in the case of category
			if ($k=='e.catid'){
				//UPDATED BY REINHARD in 1.2.8
				//check if ID is a number
				if(is_numeric($v)){
					$where.=' AND '.$k.'='.$v;
					$ccat=$v;
				}else{
				//UPDATED BY REINHARD in 1.2.8
				//ERROR Message
				}
			}

			// in case of id
			if ($k=='id'){
				//UPDATED BY REINHARD in 1.2.8
				//check if ID is a number
				if(is_numeric($v)){
					$where.=' AND e.id='.$v;
				}else{
				//UPDATED BY REINHARD in 1.2.8
				//ERROR Message
				}
			}
		}



		$this->where=$where;
		$query->where($where);
		// order and limit the query
				$orderdate = '';
			if (isset($this->options['orderby'])) {$orderdate = $this->options['orderby'];}
				// in the case of order
				if ($orderdate==0){
					$query->order('e.next');
				}
				if ($orderdate==1){
					$query->order('e.next DESC');
				}
				if ($orderdate==2){
					$query->order('e.next ASC');
				}

		$getpage=JRequest::getVar('page');


		if (!$getpage){
			$start='0';
		}else{
			$start = $this->options['number']*($getpage-1);
		}
		$query.=' LIMIT '.$start.', '.$this->options['number'];


		$db->setQuery($query);
		$loaddb = $db->loadObjectList();

		return $loaddb;
	}


	/**
	 * Event list
	 */

	// CONTAINER
	protected function container ($atr){
		$contDef=new stdClass;
		foreach ($atr as $k=>$v){
			$contDef->$k=$this->$k();
		}
		return $contDef;
	}

	// Header Events List
	protected function header ()
	{
		// Preparing connection to db
		$db	= $this->getDbo();

		// Preparing the query
		$query = $db->getQuery(true);

		// Selectable items
		$query->select('next AS tNext, dates AS tDates, period AS tPeriod, id AS tId, state AS tState, access AS tAccess');
		$query->from('`#__icagenda_events` AS e');
		$query->where(' e.state = 1 ');
		$db->setQuery($query);

		$allnext = $db->loadObjectList();

		// declare the controls
		$ctrlNext=NULL;
		$ctrlBack=NULL;
		$getpage=JRequest::getVar('page');

		// check if there are other events after those selected
		$db	= $this->getDbo();
		$query = $db->getQuery(true);
		$query->select('count(e.id) AS max')->from('#__icagenda_events AS e');


		$filters=$this->filters;
		$where='e.state ='.$filters['state'];
		unset($filters['state']);
		foreach($filters as $k=>$v){

			// normal cases
			if ($k!='key' && $k!='next' && $k!='e.catid' && $k!='e.id'){
				$where.=' AND '.$k.' LIKE "%'.$v.'%"';
			}

			// in the case of time
			if ($k=='next'){
				if($v==1) $where.=' AND e.next >= (CURDATE())';
				if($v==2) $where.=' AND e.next < (CURDATE())';
			}

			// in the case of category
			if ($k=='e.catid'){
				$where.=' AND '.$k.'='.$v;
			}
		}
		if (!$getpage){
			$start='0';
		}else{
			$start = $this->options['number']*($getpage-1);
		}
		$query.=' LIMIT '.$start.', '.($this->options['number']+1);



		$db->setQuery($query);
		$dbmax=$db->loadObject();
		$max='';
		if(isset($dbmax->max))$max=$dbmax->max;
		if ($max > $this->options['number'])$ctrlNext=1;

		// first check whether there are elements of those selected
		if($getpage && $getpage>1)$ctrlBack=1;

		// Variables declaration
		$nbevents='';$total='';$timetitle='';$timetext='';$timetext1='';$noevt='';

		$db	= $this->getDbo();
		$query = $db->getQuery(true);


		// Adding Filter per Category in Navigation - Bug Fixed 1.2.6 released
		$selcat = '';
		if (isset($this->options['mcatid'])) {$selcat = $this->options['mcatid'];}
		if ($selcat==0){
			$selcat='e.catid';
		}
		else {
			$selcat=$selcat;
		}

		// Access Control
//		$level = '1';
//		$user = JFactory::getUser();
//		$userLevels = $user->getAuthorisedViewLevels();
//		if(isset($userLevels)) $level=max ($user->getAuthorisedViewLevels());

		// Language Control
 		$lang = JFactory::getLanguage();
		$langcur = $lang->getTag();
		$langcurrent = $langcur;

		// Access Control
		$public = '1';
		$notset = '0';
		$user = JFactory::getUser();
		$userLevels = $user->getAuthorisedViewLevels();
		if(version_compare(JVERSION, '3.0', 'lt')) {
			$userGroups = $user->getAuthorisedGroups();
		} else {
			$userGroups = $user->groups;
		}

		if ($v==0){
			$query->select('count(id) AS nbevents')->from('#__icagenda_events AS e');
			$where= "(e.state > 0) AND (e.catid=$selcat) AND ((e.language = '$langcurrent') OR (e.language = '*') OR (e.language = NULL) OR (e.language = ''))" ;
			if ( !in_array('8', $userGroups) )  {
					$where.=' AND (e.access LIKE \'%'.$public.'%\' ';
					foreach ($allnext as $an) {
						$tAccess=$an->tAccess;
						$control='';
						//if ($tAccess == '0') { $tAccess='1'; }
						foreach ($userLevels as $level){
							if ($level == $tAccess) {
								$control=$tAccess;
								// in the case of access
								$where.=' OR e.access LIKE \'%'.$control.'%\' ';
								$where.=' OR e.access LIKE \'%'.$notset.'%\' ';
							}
						}
					}
					$where.=' ) ';
			}
			$query->where($where);
			$db->setQuery($query);
			$nbevents=$db->loadObject()->nbevents;
			$timetitle=''.JText::_( 'COM_ICAGENDA_ALL_TITLE' ).'';
			$timetext=''.JText::_( 'COM_ICAGENDA_ALL_TEXT' ).'';
			$timetext1=''.JText::_( 'COM_ICAGENDA_ALL_TEXT_ONE' ).'';
			$noevt=''.JText::_( 'COM_ICAGENDA_ALL_NO_EVENT_TEXT' ).'';

		}
		if ($v==1){
			$query->select('count(id) AS nbevents, e.language AS langevt, e.access AS CTAccess')->from('#__icagenda_events AS e');
			$where= "(e.next >= (CURDATE())) AND (e.state > 0) AND (e.catid=$selcat) AND ((e.language = '$langcurrent') OR (e.language = '*') OR (e.language = NULL) OR (e.language = ''))" ;
			if ( !in_array('8', $userGroups) )  {
					$where.=' AND (e.access LIKE \'%'.$public.'%\' ';
					foreach ($allnext as $an) {
						$tAccess=$an->tAccess;
						$control='';
						//if ($tAccess == '0') { $tAccess='1'; }
						foreach ($userLevels as $level){
							if ($level == $tAccess) {
								$control=$tAccess;
								// in the case of access
								$where.=' OR e.access LIKE \'%'.$control.'%\' ';
								$where.=' OR e.access LIKE \'%'.$notset.'%\' ';
							}
						}
					}
					$where.=' ) ';
			}
			$query->where($where);
			$db->setQuery($query);
			$nbevents=$db->loadObject()->nbevents;
			$langevt=$db->loadObject()->langevt;
			$ReturnList=$db->loadObjectList();
			$timetitle=''.JText::_( 'COM_ICAGENDA_FUTURE_TITLE' ).'';
			$timetext=''.JText::_( 'COM_ICAGENDA_FUTURE_TEXT' ).'';
			$timetext1=''.JText::_( 'COM_ICAGENDA_FUTURE_TEXT_ONE' ).'';
			$noevt=''.JText::_( 'COM_ICAGENDA_FUTURE_NO_EVENT_TEXT' ).'';

		}
		if ($v==2){
			$query->select('count(id) AS nbevents, e.language AS langevt')->from('#__icagenda_events AS e');
			$where= "(e.next < (CURDATE())) AND (e.state > 0) AND (e.catid=$selcat) AND ((e.language = '$langcurrent') OR (e.language = '*') OR (e.language = NULL) OR (e.language = ''))" ;
			if ( !in_array('8', $userGroups) )  {
					$where.=' AND (e.access LIKE \'%'.$public.'%\' ';
					foreach ($allnext as $an) {
						$tAccess=$an->tAccess;
						$control='';
						//if ($tAccess == '0') { $tAccess='1'; }
						foreach ($userLevels as $level){
							if ($level == $tAccess) {
								$control=$tAccess;
								// in the case of access
								$where.=' OR e.access LIKE \'%'.$control.'%\' ';
								$where.=' OR e.access LIKE \'%'.$notset.'%\' ';
							}
						}
					}
					$where.=' ) ';
			}
			$query->where($where);
			$db->setQuery($query);
			$nbevents=$db->loadObject()->nbevents;
			$langevt=$db->loadObject()->langevt;
			$timetitle=''.JText::_( 'COM_ICAGENDA_PAST_TITLE' ).'';
			$timetext=''.JText::_( 'COM_ICAGENDA_PAST_TEXT' ).'';
			$timetext1=''.JText::_( 'COM_ICAGENDA_PAST_TEXT_ONE' ).'';
			$noevt=''.JText::_( 'COM_ICAGENDA_PAST_NO_EVENT_TEXT' ).'';

		}

			$total=$nbevents;

		$report='';$report2='';$report3='';$report4='';


		if ($nbevents==1) {
			$report.= '<small> '.JText::_( 'COM_ICAGENDA_ONE_EVENT_TEXT' ).' '.$total.' '.$timetext1.' </small>';
		}
		if ($nbevents==0) {
			$report.= '<small> '.$noevt.' </small>';
		}
		if ($nbevents>1) {
			$report.= '<small> '.JText::_( 'COM_ICAGENDA_EVENTS_TEXT' ).' '.$total.' '.$timetext.' </small>';
		}
		$num=$this->options['number'];

		// No display if number not exist (checked in 1.2.8)
		if ($num == NULL) {
			$pages= 1;
		}
		else {
			$pages=ceil($total/$num);
		}

			$pon=$getpage;
		if (JRequest::getVar('page')==NULL){
			$pon=1;
		}
		if ($pages<=1) {
			$report2.= '<br/><br/>';
		}

		else {
			$report2.= ' <small> - '.JText::_( 'COM_ICAGENDA_EVENTS_PAGE' ).' '.$pon.' / '.$pages.'</small><br/><br/>';
		}

		$report3.= ' <small> '.JText::_( 'COM_ICAGENDA_EVENTS_PAGE' ).' '.$pon.' / '.$pages.'</small><br/><br/>';

		$report4.= '<br> '.JText::_( 'COM_ICAGENDA_SEARCH_RESULTS' ).' &nbsp; ';


		// create the navigator

		$allcat = '';
		if (isset($this->filters['mcatid'])) {$allcat = $this->filters['mcatid'];}

		if ($k==0  &&  $k!='key') {

		$headerList = '1';
		if (isset($this->options['headerList'])) {$headerList = $this->options['headerList'];}
		if ($headerList == 1) $header='<div><h2> '.$timetitle.' <br/></h2> '.$report.' '.$report2.'';
		if ($headerList == 2) $header='<div><h2> '.$timetitle.' </h2><br/>';
		if ($headerList == 3) $header='<div><br/>'.$report.' '.$report2.'';
		if ($headerList == 4) $header='<div><br/>';

		}
		elseif ($k=='e.catid'  &&  $k!='key') {
			$header='<div>'.$report3;
		}

		else {
			$header='<div>'.$report4;
		}



		$header.='</div>';
		return $header;
	}

	// Navigator Events list
	protected function navigator ()
	{
		// Preparing connection to db
		$db	= $this->getDbo();

		// Preparing the query
		$query = $db->getQuery(true);

		// Selectable items
		$query->select('next AS tNext, dates AS tDates, period AS tPeriod, id AS tId, state AS tState, access AS tAccess');
		$query->from('`#__icagenda_events` AS e');
		$query->where(' e.state = 1 ');
		$db->setQuery($query);

		$allnext = $db->loadObjectList();


		// declare the controls
		$ctrlNext=NULL;
		$ctrlBack=NULL;
		$getpage=JRequest::getVar('page');

		// check if there are other events after those selected
		$db	= $this->getDbo();
		$query = $db->getQuery(true);
		$query->select('count(e.id) AS max')->from('#__icagenda_events AS e');

		$filters=$this->filters;
		$where='e.state ='.$filters['state'];
		unset($filters['state']);
		foreach($filters as $k=>$v){



			// normal cases
			if ($k!='key' && $k!='next' && $k!='e.catid' && $k!='e.id'){
				$where.=' AND '.$k.' LIKE "%'.$v.'%"';
			}

			// in the case of time
			if ($k=='next'){
				if($v==1) $where.=' AND e.next >= (CURDATE())';
				if($v==2) $where.=' AND e.next < (CURDATE())';
			}

			// in the case of category
			if ($k=='e.catid'){
				$where.=' AND '.$k.'='.$v;
			}
		}
		if (!$getpage){
			$start='0';
		}else{
			$start = $this->options['number']*($getpage-1);
		}
		$query.=' LIMIT '.$start.', '.($this->options['number']+1);
		$db->setQuery($query);
		$dbmax=$db->loadObject();
		$max='';
		if(isset($dbmax->max))$max=$dbmax->max;
		if ($max > $this->options['number'])$ctrlNext=1;

		// first check whether there are elements of those selected
		if($getpage && $getpage>1)$ctrlBack=1;

		$nbevents='';$total='';$timetitle='';$timetext='';$timetext1='';$noevt='';
		$db	= $this->getDbo();
		$query = $db->getQuery(true);


		// Adding Filter per Category in Navigation - Bug Fixed 1.2.6 released
		$selcat = '';
		if (isset($this->options['mcatid'])) {$selcat = $this->options['mcatid'];}
		if ($selcat==0){
			$selcat='e.catid';
		}
		else {
			$selcat=$selcat;
		}

		// Access Control
//		$level = '1';
//		$user = JFactory::getUser();
//		$userLevels = $user->getAuthorisedViewLevels();
//		if(isset($userLevels)) $level=max ($user->getAuthorisedViewLevels());

		// Language Control
 		$lang = JFactory::getLanguage();
		$langcur = $lang->getTag();
		$langcurrent = $langcur;

		// Access Control
		$public = '1';
		$notset = '0';
		$user = JFactory::getUser();
		$userLevels = $user->getAuthorisedViewLevels();
		if(version_compare(JVERSION, '3.0', 'lt')) {
			$userGroups = $user->getAuthorisedGroups();
		} else {
			$userGroups = $user->groups;
		}


		if ($v==0){
			$query->select('count(id) AS nbevents')->from('#__icagenda_events AS e');
			$where= "(e.state > 0) AND (e.catid=$selcat) AND ((e.language = '$langcurrent') OR (e.language = '*') OR (e.language = NULL) OR (e.language = ''))" ;
			if ( !in_array('8', $userGroups) )  {
					$where.=' AND (e.access LIKE \'%'.$public.'%\' ';
					foreach ($allnext as $an) {
						$tAccess=$an->tAccess;
						$control='';
						//if ($tAccess == '0') { $tAccess='1'; }
						foreach ($userLevels as $level){
							if ($level == $tAccess) {
								$control=$tAccess;
								// in the case of access
								$where.=' OR e.access LIKE \'%'.$control.'%\' ';
								$where.=' OR e.access LIKE \'%'.$notset.'%\' ';
							}
						}
					}
					$where.=' ) ';
			}
			$query->where($where);
			$db->setQuery($query);
			$nbevents=$db->loadObject()->nbevents;
			$total=$nbevents;

		}
		if ($v==1){
			$query->select('count(id) AS nbevents')->from('#__icagenda_events AS e');
			$where= "(e.next >= (CURDATE())) AND (e.state > 0) AND (e.catid=$selcat) AND ((e.language = '$langcurrent') OR (e.language = '*') OR (e.language = NULL) OR (e.language = ''))" ;
			if ( !in_array('8', $userGroups) )  {
					$where.=' AND (e.access LIKE \'%'.$public.'%\' ';
					foreach ($allnext as $an) {
						$tAccess=$an->tAccess;
						$control='';
						//if ($tAccess == '0') { $tAccess='1'; }
						foreach ($userLevels as $level){
							if ($level == $tAccess) {
								$control=$tAccess;
								// in the case of access
								$where.=' OR e.access LIKE \'%'.$control.'%\' ';
								$where.=' OR e.access LIKE \'%'.$notset.'%\' ';
							}
						}
					}
					$where.=' ) ';
			}
			$query->where($where);
			$db->setQuery($query);
			$nbevents=$db->loadObject()->nbevents;
			$total=$nbevents;

		}
		if ($v==2){
			$query->select('count(id) AS nbevents')->from('#__icagenda_events AS e');
			$where= "(e.next < (CURDATE())) AND (e.state > 0) AND (e.catid=$selcat) AND ((e.language = '$langcurrent') OR (e.language = '*') OR (e.language = NULL) OR (e.language = ''))" ;
			if ( !in_array('8', $userGroups) )  {
					$where.=' AND (e.access LIKE \'%'.$public.'%\' ';
					foreach ($allnext as $an) {
						$tAccess=$an->tAccess;
						$control='';
						//if ($tAccess == '0') { $tAccess='1'; }
						foreach ($userLevels as $level){
							if ($level == $tAccess) {
								$control=$tAccess;
								// in the case of access
								$where.=' OR e.access LIKE \'%'.$control.'%\' ';
								$where.=' OR e.access LIKE \'%'.$notset.'%\' ';
							}
						}
					}
					$where.=' ) ';
			}
			$query->where($where);
			$db->setQuery($query);
			$nbevents=$db->loadObject()->nbevents;
			$total=$nbevents;

		}

		$num=$this->options['number'];

		// No display if number not exist (checked in 1.2.8)
		if ($num == NULL) {
			$pages= 1;
		}
		else {
			$pages=ceil($total/$num);
		}

			$pon=$getpage;
		if (JRequest::getVar('page')==NULL){
			$pon=1;
		}


		// create the navigator

		$allcat = '';
		if (isset($this->filters['mcatid'])) {$allcat = $this->filters['mcatid'];}

		if ($k==0  &&  $k!='key') {
			$nav='<div class="navigator">';
		}
		elseif ($k=='e.catid'  &&  $k!='key') {
			$nav='<div class="navigator">';
		}

		else {
			$nav='<div class="navigator">';
		}



		// idea by L.V. : insert text with forward/back arrows.
		$arrowtext = NULL;
		if(isset($this->options['arrowtext']))$arrowtext = $this->options['arrowtext'];
		// in the case of text next/prev
				if ($arrowtext==1){
					$textnext=JText::_( 'JNEXT' );
					$textback=JText::_( 'JPREV' );
				}

		$parentnav = $this->options['Itemid'];

		$mainframe = JFactory::getApplication();
		$isSef = $mainframe->getCfg( 'sef' );

		if ($isSef == '1') {
			$urlback=JRoute::_(JURI::current().'?');
			$urlnext=JRoute::_(JURI::current().'?');
		}
		if ($isSef == '0') {
			$urlback='index.php?option=com_icagenda&view=list&Itemid='.(int)$parentnav.'&';
			$urlnext='index.php?option=com_icagenda&view=list&Itemid='.(int)$parentnav.'&';
		}

		if ($pages>=2) {

		if ($ctrlBack!=NULL){
			if ($getpage && $getpage<$pages) {
				$pageBack=$getpage-1;
				$pageNext=$getpage+1;
				$nav.='<a class="icagenda_back" href="'.$urlback.'page='.$pageBack.'">&#9668; '.$textback.'&nbsp;</a>';
				$nav.='<a class="icagenda_next" href="'.$urlnext.'page='.$pageNext.'">&nbsp;'.$textnext.' &#9658;</a>';
			}
			else {
				$pageBack=$getpage-1;
				$nav.='<a class="icagenda_back" href="'.$urlback.'page='.$pageBack.'">&#9668; '.$textback.'&nbsp;</a>';
			}
		}
		if ($ctrlNext!=NULL){
			if(!$getpage){
				$pageNext=2;
			}
			else{
				$pageNext=$getpage+1;
				$pageBack=$getpage-1;
			}
			$nav.='<a class="icagenda_next" href="'.$urlnext.'page='.$pageNext.'">&nbsp;'.$textnext.' &#9658;</a>';
		}

		}

		$nav.='</div>';
		return $nav;
	}



	/**
	 * EVENT DETAILS
	 */

	protected function template (){return $this->options['template'];}
	protected function displaytime ($i){return $i->displaytime;}
	protected function access ($i){return $i->access;}
	protected function place_name ($i){return $i->place_name;}
	protected function address ($i){return $i->address;}
	protected function phone ($i){return $i->phone;}
	protected function email ($i){return $i->email;}
	protected function emailLink ($i){$emailcloack=''; $email=$i->email; if ($email != NULL) { $emailcloack= JHtml::_('email.cloak', $email); return $emailcloack; } }
	protected function website ($i){return $i->website;}
	protected function city ($i){return $i->city;}
	protected function country ($i){return $i->country;}
	protected function image ($i){return $i->image;}
	protected function file ($i){return $i->file;}
	protected function participantList ($i){
		$participantList='1';
		if (isset($this->options['participantList'])) $participantList=$this->options['participantList'];

		return $participantList;
	}

	// Get Items
	protected function items ($atr){

		// Initialize controls
		$access='0';
		$control='';

		$atr=$atr['item'];
		$items=$this->items;
		$itDef=new stdClass;
		if ($this->items == NULL) { return NULL; }
		else {
			foreach($items as $i){

				// Access Control
//				$user = JFactory::getUser();
//				$userLevels = $user->getAuthorisedViewLevels();
//				$access=$i->access;
//				if ($access == '0') { $access='1'; }

//				foreach ($userLevels as $level){
//					if ($level == $access) {
//						$control=$access;
//					}
//				}

				// Language Control
				$lang = JFactory::getLanguage();
				$eventLang = '';
				$langTag = '';
				$langTag = $lang->getTag();

				if(isset($i->language)) $eventLang=$i->language;
				if($eventLang=='') $eventLang=$langTag;
				if($eventLang=='*') {
					$eventLang=$langTag;
				}

//				if ($control == $access) {
//					if ($eventLang == $langTag) {
						$i=$this->ctrlNext($i);
						$it=new stdClass;
						$id=$i->id;
						foreach($atr as $k=>$v){
							// Corrige Notice : Undefined property: stdClass::
							if(!empty($i->$k)){
								$it->$k=$i->$k;
							}else{
								if(method_exists($this, $k)){$it->$k=$this->$k($i);}
							}
						}
					$itDef->$id=$it;
//					}
//				}

			}
		}
		return $itDef;
	}

	// Get event Url
	protected function url ($i){

		$lien = $this->options['Itemid'];
		$eventnumber = $i->id;

		$urlevent = JRoute::_('index.php?option=com_icagenda&view=list&layout=event&id='.(int)$eventnumber.'&Itemid='.(int)$lien);
		$url=$urlevent;
		if (is_numeric($lien) && is_numeric($eventnumber) && !is_array($lien) && !is_array($eventnumber)) {
			return $url;
		}
		else {
			$url = JRoute::_('index.php');
			return $url;
		}

	}

	// Title with link to details
	protected function titleLink ($i){
		$title=$i->title;
		$url=$this->url($i);
		return '<a href="'.$url.'">'.$title.'</a>';
	}

	// Title
	protected function title ($i){
		$title=$i->title;
		if ($title != NULL) {
			return $title;
		} else {
			return NULL;
		}
	}

	// Description
	protected function desc ($i){
		$desc=$i->desc;
		if ($desc != NULL) {
			return $desc;
		} else {
			return NULL;
		}
	}

	protected function description ($i){
		$description=$i->desc;
		if ($description != NULL) {
			$text = JHTML::_('content.prepare', $description);
			return $text;
		} else {
			return NULL;
		}
	}

	// Short Description
	protected function descShort ($i){
		$limit = '100';
		$limitGlobal = '0';
		if (isset($this->options['limitGlobal'])) $limitGlobal=$this->options['limitGlobal'];
		if ($limitGlobal == 1) {
			$limit = JComponentHelper::getParams('com_icagenda')->get('ShortDescLimit');
		}
		if ($limitGlobal == 0) {
			$customlimit=$this->options['limit'];
			if (is_numeric($customlimit)){
				$limit=$this->options['limit'];
			} else {
				$limit = JComponentHelper::getParams('com_icagenda')->get('ShortDescLimit');
			}
		}
		if (is_numeric($limit)) {
			$limit = $limit;
		} else {
			$limit = '1';
		}
		$readmore='';
		if ($limit <= 1) {
			$readmore='';
		} else {
			$readmore='[&#46;&#46;&#46;]';
		}
		$text=preg_replace('/<img[^>]*>/Ui', '', $i->desc);
		if(strlen($text)>$limit){
			$string_cut=substr($text, 0,$limit);
			$last_space=strrpos($string_cut,' ');
			$string_ok=substr($string_cut, 0,$last_space);
			$text=$string_ok.' ';
			$url=$this->url($i);
			$text=strip_tags($text).'<a href="'.$url.'" class="more">'.$readmore.'</a>';
		}else{
			$text=$text;
		}
		return $text;
	}

	// Image
	protected function imageTag ($i){
		//$noimg= '';
		if (!$i->image == NULL) {
			return '<img src="'.$i->image.'"/>';
		}
		//else {
		//	return $noimg;
		//}
	}

	// File
	protected function fileTag ($i){
		return '<a class="icDownload" href="'.$i->file.'">'.JText::_( 'COM_ICAGENDA_EVENT_DOWNLOAD' ).'</a>';
	}

	// Link Website
	protected function websiteLink ($i){
		$gettarget="_blanck";
		if (isset($this->options['targetLink'])) {$gettarget=$this->options['targetLink'];}
		if ($gettarget == 0){
			$target="_parent";
		} else {
			$target="_blanck";
		}
		$wsLink = $i->website;
		if (filter_var($wsLink, FILTER_VALIDATE_URL)) {
			$link = $wsLink;
		} else {
			$link = 'http://'.$wsLink;
		}

		return '<a href="'.$link.'" target="'.$target.'">'.$wsLink.'</a>';
	}





	protected function nextMkt ($i){
		return $this->mkt($i->next);
	}

	protected function pastDates ($i)
	{
		$dates=unserialize($i->dates);
		$period=unserialize($i->period);
		$toDay=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$hour= date('H');
		$min= date('i');

		$toDay=mktime($hour,$min,0,$m,$day,$y);

		if($period != NULL) {$alldates = array_merge($dates, $period);} else {$alldates = $dates;}
		rsort($alldates);
		$lastDate = $this->mkt($alldates[0]);

		if (($lastDate < $toDay)) {
			$pastDates = '0';
		}
		else {
			$pastDates = '1';
		}
			return $pastDates;
	}



	/**
	 * TIME
	 */

	// Format Time (eg. 00:00)
	protected function evenTime ($i){
		$date_time = $this->mkt($i->next);
 		$time_format = 'H:i';
 		$t_time=date($time_format, $date_time);
		$timeformat='1';
		if (isset($this->options['timeformat'])) {$timeformat=$this->options['timeformat'];}

		if ($timeformat == 1) {
			$lang_time = strftime("%H:%M", strtotime("$t_time"));
		} else {
			$lang_time = strftime("%I:%M %p", strtotime("$t_time"));
		}

		$oldtime = $i->time;
		if ($oldtime != NULL){
			$time = $i->time;
		} else {
			$time = JText::_($lang_time);
		}
		$displayTime=$i->displaytime;
		if ($displayTime == 1) {
			return $time;
		} else {
			return NULL;
		}
	}


	/**
	 * DAY
	 */

	// Day
	protected function day ($i){
		return date('d', $this->mkt($i->next));
	}


	/**
	 * MONTHS
	 */

	// Function used for special characters
	function substr_unicode($str, $s, $l = null) {
    	return join("", array_slice(
		preg_split("//u", $str, -1, PREG_SPLIT_NO_EMPTY), $s, $l));
	}

	// Format Month (eg. December)
	protected function month ($i){
		$mkt_date = $this->mkt($i->next);
		$dateFormat=date('d-M-Y', $mkt_date);
		$l_full_month = strftime("%B", strtotime("$dateFormat"));
		$lang_month = JText::_($l_full_month);
		$month = $lang_month;
		return $month;
	}

	// Format Month Short - 3 first characters (eg. Dec.)
	protected function monthShort ($i){
		$mkt_date=$this->mkt($i->next);
		$dateFormat=date('d-M-Y', $mkt_date);
		$l_full_month = strftime("%B", strtotime("$dateFormat"));
		$lang_month = JText::_($l_full_month);
		$monthShort = $this->substr_unicode($lang_month,0,3);
		$space='';
		$point='';
		if(strlen($l_full_month)>3){
			$space='&nbsp;';
			$point='.';
		}
		return $space.$monthShort.$point;
	}

	// Format Month Short Core - From Joomla language file xx-XX.ini (eg. Dec)
	protected function monthShortJoomla ($i){
		$mkt_date=$this->mkt($i->next);
		$dateFormat=date('d-M-Y', $mkt_date);
		$l_full_month = strftime("%B", strtotime("$dateFormat"));
		$monthShortJoomla = JText::_($l_full_month.'_SHORT');
		return $monthShortJoomla;
	}

	// Format Month Numeric - (eg. 07)
	protected function monthNum ($i){
		return $this->formatDate($i->next, 'm');
	}


	/**
	 * YEAR
	 */

	// Format Year Numeric - (eg. 2013)
	protected function year ($i){
		return date('Y', $this->mkt($i->next));
	}

	// Format Year Short Numeric - (eg. 13)
	protected function yearShort ($i){
		return date('y', $this->mkt($i->next));
	}


	/**
	 * DATES
	 */

	// Next Date Text
	protected function dateText ($i)
	{
		$dates=unserialize($i->dates);
		$period=unserialize($i->period);
		$toDay=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$toDay=mktime(0,0,0,$m,$day,$y);

		if($period != NULL) {$alldates = array_merge($dates, $period);} else {$alldates = $dates;}

			$nextDate = $i->next;
			$next = $this->mktshort($nextDate);

				$totDates = count($alldates);

		if (($next > $toDay) AND ($totDates > 1)) {
			rsort($alldates);
			$lastdate = '';
			$lastdate = $this->mkt($alldates[0]);
			if ($lastdate == $next) {
				$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE_LAST' ).'';
			} else {
				$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE_FUTUR' ).'';
			}

		}
		if (($next > $toDay) AND ($totDates <= 1)) {
			$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE' ).'';
		}
		if (($next < $toDay) AND ($totDates > 1)) {
			$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE_PAST' ).'';
		}
		if (($next < $toDay) AND ($totDates <= 1)) {
			$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE' ).'';
		}
		if ($next == $toDay) {
			$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE_TODAY' ).'';
		}
			return $dateText;
	}

	// Get Next Date (or Last Date)
	protected function nextDate ($i){

/* Remove from 3.0.2
		$dates=unserialize($i->dates);
		if (isset($i->period)) {
			$period=unserialize($i->period);
		} else {
			$period=unserialize($i->dates);
		}

		$daysptest = '';
		$daysdtest = $dates[0];

		if (($daysdtest == '0000-00-00 00:00:00') AND ($period != NULL)) {
			$DatesList=$period;
			$alldates=$DatesList;
		}
		if (($daysdtest != '0000-00-00 00:00:00') AND ($period != NULL)) {
			$DatesList=array_merge($dates, $period);
			$alldates=$DatesList;
		}
		if (($daysdtest != '0000-00-00 00:00:00') AND ($period == NULL)) {
			$DatesList=$dates;
			$alldates=$DatesList;
		}

		rsort($alldates);

		$today=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$hour= date('H');
		$min= date('i');
		$today=mktime(0,0,0,$m,$day,$y);

		if ($i->next <= $today) {
			$dd = $this->mkt($alldates[0]);
			foreach($alldates as $a){
				$d=$this->mkt($a);
				if ($dd < $today){
					$i->next=date('Y-m-d H:i', $dd);
				}
				elseif ($d>=$today){
					$i->next=date('Y-m-d H:i', $d);
				}
			}
		}

		$next=$i->next;

		$db		= JFactory::getDBO();
//		$db		= $this->getDbo();
		$query	= $db->getQuery(true);

		$query->update('#__icagenda_events');
		$query->set("`next`='".$next."'");
		$query->where('`id`='.(int)$i->id);
		$db->setQuery($query);
		$db->query($query);

END Remove */
		$today=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$hour= date('H');
		$min= date('i');
		$today=mktime(0,0,0,$m,$day,$y);
		$testDate = $this->mkt($i->next);
		if ($testDate == $today) {
			$nextDate = '<b>'.$this->formatDate($i->next).'</b>';
		}
		else {
			$nextDate = $this->formatDate($i->next);
		}
			return $nextDate;
	}

	// Control Upcoming dates Period
	protected function periodControl ($i){
		$upPeriod = '1';
		$endDate = $i->enddate;
		$mktendDate=$this->mkt($endDate);
		$today=time();
		if ($mktendDate > $today) {
			return $upPeriod;
		}

	}

	// Dates Drop list Registration
	protected function datelistMkt ($i){
		$daysd=unserialize($i->dates);
		if(isset($i->period)) {$daysp=unserialize($i->period);}
		$today=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$hour= date('H');
		$min= date('i');
		$toDay=mktime($hour,$min,0,$m,$day,$y);
		$daysptest = '';
		sort($daysd);
		if($i->period!='') {sort($daysp);}
		$daysdtest = $this->mkt($daysd[0]);

		if (($this->periodTest($i) == '1') && (isset($i->period))) {
			$daysptest = $this->mkt($daysp[0]);
		} else {
			$daysptest == '943916400';
		}

//		if (($daysdtest == '943916400') AND ($daysptest != NULL)) {
//			$Testdays=$daysp;
//			foreach ($Testdays as $d){
//				$Testday=$this->mkt($d);
//			}
//		}
//		if (($daysdtest != '943916400') AND ($daysptest != NULL)) {
//			$Testdays=array_merge($daysd, $daysp);
//			foreach ($Testdays as $d){
//				$Testday=$this->mkt($d);
//			}
//		}
//		if (($daysdtest != '943916400') AND ($daysptest == NULL)) {
//			$Testdays=$daysd;
//			foreach ($Testdays as $d){
//				$Testday=$this->mkt($d);
//			}
//		}

		$timeformat='1';
		if (isset($this->options['timeformat'])) {$timeformat=$this->options['timeformat'];}
		if ($timeformat == 1) {
			$lang_time = 'H:i';
		} else {
			$lang_time = 'h:i A';
		}

		$displaytime = $this->displaytime($i);
		$upDays='';
//		if ($Testday > $toDay) {
			if (($daysdtest == '943916400') AND ($daysptest != NULL)) {
				$days=$daysp;
				foreach ($days as $k=>$d){
					$dd=$this->mkt($d);
				if ($dd > $today) {
					$date=$this->formatDate($d);
					if ($displaytime == 1) {
						$upDays[$k]=$date.' - '.date($lang_time, $dd);
					} else {
						$upDays[$k]=$date;
					}
				}
				}
				return $upDays;
			}
			if (($daysdtest != '943916400') AND ($daysptest != NULL)) {
				$days=array_merge($daysd, $daysp);
				sort($days);
				foreach ($days as $k=>$d){
					$dd=$this->mkt($d);
				if ($dd > $today) {
					$date=$this->formatDate($d);
					if ($displaytime == 1) {
						$upDays[$k]=$date.' - '.date($lang_time, $dd);
					} else {
						$upDays[$k]=$date;
					}
				}
				}
				return $upDays;
			}
			if (($daysdtest != '943916400') AND ($daysptest == NULL)) {
				$days=$daysd;
				foreach ($days as $k=>$d){
					$dd=$this->mkt($d);
				if ($dd > $today) {
					$date=$this->formatDate($d);
					if ($displaytime == 1) {
						$upDays[$k]=$date.' - '.date($lang_time, $dd);
					} else {
						$upDays[$k]=$date;
					}
				}
				}
				return $upDays;
			}
//		}
	}

	// All Single Dates in Event Details Page
	protected function datelistUl ($i){
		$days=unserialize($i->dates);
		$totDates = count($days);

		$timeformat='1';
		if (isset($this->options['timeformat'])) {$timeformat=$this->options['timeformat'];}
		if ($timeformat == 1) {
			$lang_time = 'H:i';
		} else {
			$lang_time = 'h:i A';
		}

		$displaytime = $this->displaytime($i);

//		$n=0;
//		$daysUl='<div class="alldates">';
//		foreach ($days as $k=>$a){
//			$n=$n+1;
//			$fd=$this->formatDate($a);
// 			$dd=$this->mkt($a);
//
//			if ($displaytime == 1) {
//				$timeDate=' <span class="evttime">'.date($lang_time, $dd).'</span>';
//			} else {
//				$timeDate='';
//			}
//			if ($n<=$nbmax) {
//				$daysUl.='<span class="alldates">'.$fd.'</span> | '.$timeDate;
//			}
//			if ($n==$nbusers) {
//	   			$daysUl.='<span class="alldates">'.$fd.'</span>';
//			}
//		}

//		$daysUl.='</div>';


		$daysUl='<ul class="alldates">';
		foreach ($days as $k=>$a){
			$fd=$this->formatDate($a);
			$dd=$this->mkt($a);

			if ($displaytime == 1) {
				$timeDate=' <span class="evttime">'.date($lang_time, $dd).'</span>';
			} else {
				$timeDate='';
			}
			$daysUl.='<li class="alldates">'.$fd.$timeDate.'</li>';
		}
		$daysUl.='</ul>';

		if (($totDates > '0') && ($a!='0000-00-00 00:00:00')) {
		return $daysUl;
		}
	}

	// Function Period Display in Registration
	protected function periodDisplay ($i){
		if ($this->periodTest($i) == '1') {
			if (($i->startdate!='0000-00-00 00:00:00') OR ($i->enddate!='0000-00-00 00:00:00')) {
				$show = '1';
				return $show;
			}
		}
	}

	// Format Start Date of a period
	protected function startDate ($i){
		$start=$this->formatDate($i->startdate);
		return $start;
	}

	// Format End Date of a period
	protected function endDate ($i){
		$end=$this->formatDate($i->enddate);
		return $end;
	}

	// Start Day of a period (numeric 1)
	protected function startDay ($i){
		$start_day='';
		$start_day = $this->mkt($i->startdate);
 		$day_format = 'd-m-Y';
 		$d_day=date($day_format, $start_day);
		$format = '%e';
		if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN') {
    		$format = preg_replace('#(?<!%)((?:%%)*)%e#', '\1%#d', $format);
		}
		$startDay = strftime($format, strtotime("$d_day"));
		$day = JText::_($startDay);
		if ($i->startdate!='0000-00-00 00:00:00') {
			return $startDay;
		} else {
			return '&nbsp;&nbsp;';
		}
	}

	// End Day of a period (numeric 1)
	protected function endDay ($i){
		$end_day = '';
		$end_day = $this->mkt($i->enddate);
 		$day_format = 'd-m-Y';
 		$d_day=date($day_format, $end_day);
		$format = '%e';
		if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN') {
    		$format = preg_replace('#(?<!%)((?:%%)*)%e#', '\1%#d', $format);
		}
		$endDay = strftime($format, strtotime("$d_day"));
		$day = JText::_($endDay);
		if ($i->enddate!='0000-00-00 00:00:00') {
			return $endDay;
		} else {
			return '&nbsp;&nbsp;';
		}
	}

	// End Month of a period (numeric 01)
	protected function endMonthNum ($i){
		$end_month = $this->mkt($i->enddate);
 		$month_format = 'd-m-Y';
 		$m_month=date($month_format, $end_month);
		$endMonth = strftime("%m", strtotime("$m_month"));
		$month = JText::_($endMonth);
		return $month;
	}

	// End Month of a period (text January)
	protected function endMonth ($i){
		$end_month = $this->mkt($i->enddate);
 		$month_format = 'd-m-Y';
 		$m_month=date($month_format, $end_month);
		$endMonth = strftime("%B", strtotime("$m_month"));
		$month = JText::_($endMonth);
		return $month;
	}

	// End Year of a period (numeric 2001)
	protected function endYear ($i){
		$end_year = $this->mkt($i->enddate);
 		$year_format = 'd-m-Y';
 		$y_year=date($year_format, $end_year);
		$endYear = strftime("%Y", strtotime("$y_year"));
		$year = JText::_($endYear);
		return $year;
	}

	// Format Start Time of a period
	protected function startTime ($i){
		$start_time = $this->mkt($i->startdate);

		$timeformat='1';
		if (isset($this->options['timeformat'])) {$timeformat=$this->options['timeformat'];}
		if ($timeformat == 1) {
			$lang_time = 'H:i';
		} else {
			$lang_time = 'h:i A';
		}

 		$time_format = $lang_time;
 		$time=date($time_format, $start_time);

		$displaytime = $this->displaytime($i);
		if ($displaytime == 1) {
			return $time;
		} else {
			return NULL;
		}
	}

	// Format End Time of a period
	protected function endTime ($i){
		$end_time = $this->mkt($i->enddate);

		$timeformat='1';
		if (isset($this->options['timeformat'])) {$timeformat=$this->options['timeformat'];}
		if ($timeformat == 1) {
			$lang_time = 'H:i';
		} else {
			$lang_time = 'h:i A';
		}

 		$time_format = $lang_time;
 		$time=date($time_format, $end_time);

		$displaytime = $this->displaytime($i);
		if ($displaytime == 1) {
			return $time;
		} else {
			return NULL;
		}
	}

	// Display period text width Format Date (eg. from 00-00-0000 to 00-00-0000)
	protected function periodDates ($i){
		$start=$this->formatDate($i->startdate);
		$end=$this->formatDate($i->enddate);
		$period='<ul class="alldates"><li>'. JText::_( 'COM_ICAGENDA_PERIOD_FROM' ).' '.$start.' '. JText::_( 'COM_ICAGENDA_PERIOD_TO' ).' '.$end.'</li></ul>';
		if ($this->periodTest($i) == '1') {
			if (($i->startdate!='0000-00-00 00:00:00') AND ($i->enddate!='0000-00-00 00:00:00')) {
				return $period;
			}
		}
	}

	// Function to get Format Date (using option format, and translation)
	protected function formatDate ($d){
		$mkt_date=$this->mkt($d);

		// get Format
		$for = '0';
		if(isset($this->options['format'])) $for=$this->options['format'];

		// default
		if (($for == NULL) OR ($for == '0')) {$for = 'd * m * Y';}

		// update format values, from 2.0.x to 2.1
		if ($for == 'l, d Fnosep Y') {$for = 'l, _ d _ Fnosep _ Y';}
		if ($for == 'D d Mnosep Y') {$for = 'D _ d _ Mnosep _ Y';}
		if ($for == 'l, Fnosep d, Y') {$for = 'l, _ Fnosep _ d, _ Y';}
		if ($for == 'D, Mnosep d, Y') {$for = 'D, _ Mnosep _ d, _ Y';}

		// update format values, from release 2.1.6 and before, to 2.1.7 (using globalization)
		if ($for == 'd m Y') {$for = 'd * m * Y';}
		if ($for == 'd m y') {$for = 'd * m * y';}
		if ($for == 'Y m d') {$for = 'Y * m * d';}
		if ($for == 'Y M d') {$for = 'Y * M * d';}
		if ($for == 'd F Y') {$for = 'd * F * Y';}
		if ($for == 'd M Y') {$for = 'd * M * Y';}
		if ($for == 'd msepb') {$for = 'd * m';}
		if ($for == 'msepa d') {$for = 'm * d';}
		if ($for == 'Fnosep _ d, _ Y') {$for = 'F _ d , _ Y';}
		if ($for == 'Mnosep _ d, _ Y') {$for = 'M _ d , _ Y';}
		if ($for == 'l, _ d _ Fnosep _ Y') {$for = 'l , _ d _ F _ Y';}
		if ($for == 'D _ d _ Mnosep _ Y') {$for = 'D _ d _ M _ Y';}
		if ($for == 'l, _ Fnosep _ d, _ Y') {$for = 'l , _ F _ d, _ Y';}
		if ($for == 'D, _ Mnosep _ d, _ Y') {$for = 'D , _ M _ d, _ Y';}
		if ($for == 'd _ Fnosep') {$for = 'd _ F';}
		if ($for == 'Fnosep _ d') {$for = 'F _ d';}
		if ($for == 'd _ Mnosep') {$for = 'd _ M';}
		if ($for == 'Mnosep _ d') {$for = 'M _ d';}
		if ($for == 'Y. F d.') {$for = 'Y . F d .';}
		if ($for == 'Y. M. d.') {$for = 'Y . M . d .';}
		if ($for == 'Y. F d., l') {$for = 'Y . F d . , l';}
		if ($for == 'F d., l') {$for = 'F d . , l';}


		// NEW DATE FORMAT GLOBALIZED 2.1.7

		$lang = JFactory::getLanguage();
		$langTag = $lang->getTag();
		$langName = $lang->getName();
		if(!file_exists(JPATH_ADMINISTRATOR.'/components/com_icagenda/globalization/'.$langTag.'.php')){

			$langTag='en-GB';
		}

		$globalize = JPATH_ADMINISTRATOR.'/components/com_icagenda/globalization/'.$langTag.'.php';
		$iso = JPATH_ADMINISTRATOR.'/components/com_icagenda/globalization/iso.php';

		if (is_numeric($for)) {
			require $globalize;
		} else {
			require $iso;
		}

		// Load Globalization Date Format if selected
		if ($for == '1') {$for = $datevalue_1;}
		if ($for == '2') {$for = $datevalue_2;}
		if ($for == '3') {$for = $datevalue_3;}
		if ($for == '4') {$for = $datevalue_4;}
		if ($for == '5') {
			if (($langTag == 'en-GB') OR ($langTag == 'en-US')) {
				$for = $datevalue_5;
			} else {
				$for = $datevalue_4;
			}
		}
		if ($for == '6') {$for = $datevalue_6;}
		if ($for == '7') {$for = $datevalue_7;}
		if ($for == '8') {$for = $datevalue_8;}
		if ($for == '9') {
			if ($langTag == 'en-GB') {
				$for = $datevalue_9;
			} else {
				$for = $datevalue_7;
			}
		}
		if ($for == '10') {
			if ($langTag == 'en-GB') {
				$for = $datevalue_10;
			} else {
				$for = $datevalue_8;
			}
		}
		if ($for == '11') {$for = $datevalue_11;}
		if ($for == '12') {$for = $datevalue_12;}

		// Explode components of the date
		$exformat = explode (' ', $for);
		$format='';
		$separator = ' ';

		// Day with no 0 (test if Windows server)
		$dayj = '%e';
		if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN') {
    		$dayj = preg_replace('#(?<!%)((?:%%)*)%e#', '\1%#d', $dayj);
		}

		// Date Formatting using strings of Joomla Core Translations
		$dateFormat=date('d-M-Y', $mkt_date);
		if (isset($this->options['date_separator'])) $separator = $this->options['date_separator'];
		foreach($exformat as $k=>$val){
			switch($val){

				// day (v2)
				case 'd': $val=date("d", strtotime("$dateFormat")); break;
				case 'j': $val=strftime("$dayj", strtotime("$dateFormat")); break;
				case 'D': $val=JText::_(strftime("%a", strtotime("$dateFormat"))); break;
				case 'l': $val=JText::_(strftime("%A", strtotime("$dateFormat"))); break;
				case 'dS': $val=strftime("%d", strtotime("$dateFormat")).'<sup>'.date("S", strtotime("$dateFormat")).'</sup>'; break;
				case 'jS': $val=strftime("$dayj", strtotime("$dateFormat")).'<sup>'.date("S", strtotime("$dateFormat")).'</sup>'; break;

				// month (v2)
				case 'm': $val=strftime("%m", strtotime("$dateFormat")); break;
				case 'F': $val=JText::_(strftime("%B", strtotime("$dateFormat"))); break;
				case 'M': $val=JText::_(strftime("%B", strtotime("$dateFormat")).'_SHORT'); break;
				case 'n': $val=date("n", strtotime("$dateFormat")); break;

				// year (v2)
				case 'Y': $val=strftime("%Y", strtotime("$dateFormat")); break;
				case 'y': $val=strftime("%g", strtotime("$dateFormat")); break;

				// separators of the components (v2)
				case '*': $val=$separator; break;
				case '_': $val=' '; break;
				case '/': $val='/'; break;
				case '.': $val='.'; break;
				case '-': $val='-'; break;
				case ',': $val=','; break;
				case 'the': $val='the'; break;
				case 'gada': $val='gada'; break;
				case 'de': $val='de'; break;
				case 'г.': $val='г.'; break;
				case 'den': $val='den'; break;



				// day
				case 'N': $val=strftime("%u", strtotime("$dateFormat")); break;
				case 'w': $val=strftime("%w", strtotime("$dateFormat")); break;
				case 'z': $val=strftime("%j", strtotime("$dateFormat")); break;

				// week
				case 'W': $val=strftime("%W", strtotime("$dateFormat")); break;

				// month
				case 'n': $val=$separator.date("n", strtotime("$dateFormat")).$separator; break;

				// time
				case 'H': $val=strftime("%H", strtotime("$dateFormat")); break;
				case 'i': $val=strftime("%i", strtotime("$dateFormat")); break;


				default: $val=''; break;
			}
			if($k!=0)$format.=''.$val;
			if($k==0)$format.=$val;
		}
		return $format;
	}


	/**
	 * GOOGLE MAPS
	 */

	// Latitude
	protected function lat ($i){
		if (($i->coordinate != NULL) AND ($i->lat == '0.0000000000000000')) {
			$ex=explode(', ', $i->coordinate);
			$latresult = $ex[0];
		} elseif ($i->lat != '0.0000000000000000') {
			$latresult = $i->lat;
		} else {
			$latresult = NULL;
		}
		return $latresult;
	}

	// Longitude
	protected function lng ($i){
		if (($i->coordinate != NULL) AND ($i->lng == '0.0000000000000000')) {
			$ex=explode(', ', $i->coordinate);
			$lngresult = $ex[1];
		} elseif ($i->lng != '0.0000000000000000') {
			$lngresult = $i->lng;
		} else {
			$lngresult = NULL;
		}
		return $lngresult;
	}

	// Function Map
	protected function map ($i){
		$maplat=$this->lat($i);
		$maplng=$this->lng($i);
		$mapid=$i->id;

	//<script type="text/javascript"> var lat = '.$maplat.'; var lng = '.$maplng.'; var id = '.$mapid.';</script>
		return '<script type="text/javascript">
window.onload = function() {
   initialize('.$maplat.', '.$maplng.', '.(int)$mapid.');
}
</script><div class="icagenda_map" id="map_canvas'.(int)$mapid.'" style="width:'.$this->options['m_width'].'; height:'.$this->options['m_height'].'"></div>';
	}

	// Function Map
	protected function coordinate ($i){
		$maplat=$this->lat($i);
		$maplng=$this->lng($i);
		if (($maplat != NULL) && ($maplng != NULL)) {
			return true;
		}
	}


	/**
	 * Registered Users List
	 */

	// Display Title List of Participants (if no slide effect)
	protected function participantListTitle ($i){
		$participantList='';
		$participantSlide='';
		if (isset($this->options['participantList'])) $participantList=$this->options['participantList'];
		if (isset($this->options['participantSlide'])) $participantSlide=$this->options['participantSlide'];
		$registration = '';
		$registration = $this->statutReg($i);
		if (($participantSlide == 0 ) && ($registration == 1) && ($participantList == 1)) {
			return JText::_( 'COM_ICAGENDA_EVENT_LIST_OF_PARTICIPANTS');
		}
	}

	// Display Registered Users
	protected function registeredUsers ($i){
		$userReg='';

		// Preparing connection to db
		$db	= $this->getDbo();
		// Preparing the query
		$query = $db->getQuery(true);
		$query->select(' r.name AS registeredUsers, r.date as regDate, r.people as regPeople, r.email as regEmail ')->from('#__icagenda_registration AS r')->where('(r.eventId='.(int)$i->id.') AND (r.state > 0)');
		$db->setQuery($query);
		$registeredUsers = $db->loadObjectList();
		$nbusers=count($registeredUsers);
		$nbmax=$nbusers-1;
		$registration = '';
		$registration = $this->statutReg($i);
		$n='0';

		$participantList='1';
		$participantSlide='1';
		$participantDisplay='1';
		$fullListColumns='tiers';
		$iCagendaParams = JComponentHelper::getParams('com_icagenda');
		if (isset($this->options['participantList'])) $participantList=$this->options['participantList'];

		$participantSlide=$iCagendaParams->get('participantSlide');
		if (isset($this->options['participantDisplay'])) $participantDisplay=$this->options['participantDisplay'];
		if (isset($this->options['fullListColumns'])) $fullListColumns=$this->options['fullListColumns'];

		jimport( 'joomla.html.html.sliders' );
		$slider_c='';
		if (($participantList == 1) && ($registration == 1)) {
			$n_list='names_noslide';
			if ($participantSlide == 1) {
				$n_list='names_slide';
				$slider_c='class="pane-slider content"';
				$userReg.=JHtml::_('sliders.start', 'icagenda', array('useCookie'=>0, 'startOffset'=>-1, 'startTransition'=>1));
				$userReg.=JHtml::_('sliders.panel', JText::_('COM_ICAGENDA_EVENT_LIST_OF_PARTICIPANTS'), 'slide1');
			}

//			$userReg.='<div style="display:block; float:left; width:100%; height:5px;">&nbsp;</div>';
//			$userReg.='<div style="width:100%; text-align:justify;">';
			if ($nbusers==NULL) {
				$userReg.='<div '.$slider_c.'>';
				$userReg.='&nbsp;'.JText::_( 'COM_ICAGENDA_NO_REGISTRATION').'&nbsp;';
				$userReg.='</div>';
			} else {


			if ($participantDisplay == 1) {

				$column='tiers';
				if(isset($fullListColumns)) {$column=$fullListColumns;}
				$userReg.='<div '.$slider_c.'>';

				foreach ($registeredUsers as $reguser){
					$avatar=md5( strtolower( trim( $reguser->regEmail ) ) );
					$n=$n+1;

					if ($n<=$nbmax) {
						$userReg.='<table class="list_table '.$column.'" cellpadding="0" cellspacing="0"><tbody><tr><td class="imgbox"><img alt="'.$reguser->registeredUsers.'"  src="http://www.gravatar.com/avatar/'.$avatar.'?s=36&d=mm"/></td><td valign="middle"><span class="list_name">'.$reguser->registeredUsers.'</span><span class="list_places"> ('.$reguser->regPeople.')</span><br /><span class="list_date">'.$reguser->regDate.'</span></td></tr></tbody></table>';
					}
					if ($n==$nbusers) {
	   					$userReg.='<table class="list_table '.$column.'" cellpadding="0" cellspacing="0"><tbody><tr><td class="imgbox"><img alt="'.$reguser->registeredUsers.'"  src="http://www.gravatar.com/avatar/'.$avatar.'?s=36&d=mm"/></td><td valign="middle"><span class="list_name">'.$reguser->registeredUsers.'</span><span class="list_places"> ('.$reguser->regPeople.')</span><br /><span class="list_date">'.$reguser->regDate.'</span></td></tr></tbody></table>';
					}
				}

				$userReg.='</div>';

			}
			if ($participantDisplay == 2) {

				$userReg.='<div '.$slider_c.'>';

				foreach ($registeredUsers as $reguser){
					$avatar=md5( strtolower( trim( $reguser->regEmail ) ) );
					$n=$n+1;
					if ($n<=$nbmax) {
						$userReg.='<div style="width: 76px; height: 80px; float:left; margin:2px; text-align:center;"><img style="border-radius: 3px 3px 3px 3px; margin:2px 0px;" alt="'.$reguser->registeredUsers.'"  src="http://www.gravatar.com/avatar/'.$avatar.'?s=48&d=mm"/><br/><strong style="text-align:center; font-size:9px;">'.$reguser->registeredUsers.'</strong></div>';
					}
					if ($n==$nbusers) {
	   					$userReg.='<div style="width: 76px; height: 80px; float:left; margin:2px; text-align:center;"><img style="border-radius: 3px 3px 3px 3px; margin:2px 0px;" alt="'.$reguser->registeredUsers.'"  src="http://www.gravatar.com/avatar/'.$avatar.'?s=48&d=mm"/><br/><strong style="text-align:center; font-size:9px;">'.$reguser->registeredUsers.'</strong></div>';
					}
				}

				$userReg.='</div>';

			}
			if ($participantDisplay == 3) {

				$userReg.='<div '.$slider_c.'>';

				$userReg.='<div class="'.$n_list.'">';
				foreach ($registeredUsers as $reguser){
					$n=$n+1;
					if ($n<=$nbmax) {
						$userReg.=''.$reguser->registeredUsers.', ';
					}
					if ($n==$nbusers) {
	   					$userReg.=''.$reguser->registeredUsers.'';
					}
				}

				$userReg.='</div>';
				$userReg.='</div>';

			}

			}
//			$userReg.='</div>';
			if ($participantSlide == 1 ) {
//		   		$userReg.='<div class="icpanel-bottom">&nbsp;</div>';
				$userReg.=JHtml::_('sliders.end');
			}
		} else {
			$userReg.='';
		}
		return $userReg;
	}


	/**
	 * SPECIAL FUNCTIONS
	 */

	// function Event Options
	protected function evtParams ($i){
		$evtParams = '';
		$evtParams = new JRegistry($i->params);
		return $evtParams;
	}

	// Function if Period Dates exist
	protected function periodTest ($i){
		$daysp=unserialize($i->period);
		if ($daysp!=NULL) {
			$test = '1';
			return $test;
		}
	}

	// function to detect if info details exist in an event
	protected function infoDetails ($i){
		if ((!$this->placeLeft($i)) && (!$i->phone) && (!$i->email) && (!$i->website) && (!$i->address) && (!$i->file)) {
			return false;
		} else {
			return true;
		}
	}

//	protected function idMenu ($i){
//		$idmenu = $this->options['Itemid'];
//		return $idmenu;
//	}


	/**
	 * ADDTHIS - Social Networks
	 */

	// function to override general options display of AddThis in event details view
	protected function ateventshow ($i){
		$atevent = '';
		if (isset($this->options['atevent'])) {$atevent = $this->options['atevent'];}

//		$eventparam = new JRegistry($i->params);
//		$eventatvent =$eventparam->get('atevent');
		$param = $this->evtParams($i);
		$eventatvent = $param->get('atevent');

		//echo $atevent.'|'.$eventatvent;
		if ($eventatvent==0) {
			$show=0 ;
		}
		if (($eventatvent==1) && ($atevent==NULL)) {
			$show=1;
		}
		if ($eventatvent==1) {
			$show=1;
		}
		if ($eventatvent==NULL) {
			$show = $atevent;
		}
		return $show;
	}

	// function option display AddThis social networks sharing
	protected function share_event ($i){

		$at = $this->ateventshow($i);
		if ($at == 1) {
			$share=$this->share($i);
		} else {
			$share=NULL;
		}
		return $share;
	}

	// function AddThis social networks sharing
	protected function share ($i){

		$float='';
		if(isset($this->options['atfloat'])) { $float = $this->options['atfloat']; }
		$icon = $this->options['aticon'];
		$iconaddthis='';
		if ($float==0) {
			$floataddthis='default';
			$posfloat='right';
		}
		if ($float==1) {
			$floataddthis='floating';
			$posfloat='left';
		}
		if ($float==2) {
			$floataddthis='floating';
			$posfloat='right';
		}
		if ($icon==1) {
			$iconaddthis='16x16';
		}
		if ($icon==2) {
			$iconaddthis='32x32';
		}
		$text='<div class="share">';
		$text.='<!-- AddThis Button BEGIN -->';
		$text.='<div class="addthis_toolbox addthis_'.$floataddthis.'_style addthis_'.$iconaddthis.'_style" style="'.$posfloat.':50px;top:40%;">';
		$text.='<a class="addthis_button_preferred_1"></a>';
		$text.='<a class="addthis_button_preferred_2"></a>';
		$text.='<a class="addthis_button_preferred_3"></a>';
		$text.='<a class="addthis_button_preferred_4"></a>';
		$text.='<a class="addthis_button_compact"></a>';
		$text.='<a class="addthis_counter addthis_bubble_style"></a>';
		$text.='</div>';

		$addthis = '';
		if (isset($this->options['addthis'])) {$addthis = $this->options['addthis'];}
		if ($addthis) {
			$text.='<script type="text/javascript">var addthis_config = {"data_track_addressbar":true};</script>';
			$text.='<script type="text/javascript" src="http://s7.addthis.com/js/250/addthis_widget.js#pubid='.$this->options['addthis'].'"></script>';
		}
		else {
			$text.='<script type="text/javascript">var addthis_config = {"data_track_addressbar":false};</script>';
			$text.='<script type="text/javascript" src="http://s7.addthis.com/js/250/addthis_widget.js#pubid=ra-5024db5322322e8b"></script>';
		}
		$text.='<!-- AddThis Button END -->';
		$text.='</div>';

		return $text;
	}


	/**
	 * REGISTRATIONS
	 */

	// function link to registration page
	protected function regUrl ($i){
		return JROUTE::_('index.php?option=com_icagenda&view=list&layout=registration&Itemid='.(int)$this->options['Itemid'].'&id='.(int)$i->id);
	}

	// function Registration statut
	protected function statutReg ($i){
		$statutReg = '';
		$gstatutReg = '';
		if (isset($this->options['statutReg'])) {$gstatutReg = $this->options['statutReg'];}

		$param = $this->evtParams($i);
		$evtstatutReg = $param->get('statutReg');

// Control and edit param values to iCagenda v3
		if ($evtstatutReg == '2') {
			$evtstatutReg = '0';
		}


		if ($evtstatutReg != '') {
			$statutReg = $evtstatutReg;
		} else {
			$statutReg = $gstatutReg;
		}
		return $statutReg;
	}

	// function Registration Access
	protected function accessReg ($i){
		$accessReg = '';

		$param = $this->evtParams($i);
		$accessReg = $param->get('accessReg');

		return $accessReg;
	}

	// function Registration Type
	protected function typeReg ($i){
		$typeReg = '';
//		if (isset($this->options['typeReg'])) {$maxRlist = $this->options['typeReg'];}

		$param = $this->evtParams($i);
		$typeReg = $param->get('typeReg');

		return $typeReg;
	}

	// function Max places per registration
	protected function maxRlist ($i){
		$maxRlist = '';
		$gmaxRlist = '';
		if (isset($this->options['maxRlist'])) {$gmaxRlist = $this->options['maxRlist'];}

		$param = $this->evtParams($i);
		$evtmaxRlistGlobal = $param->get('maxRlistGlobal');
		$evtmaxRlist = $param->get('maxRlist');

// Control and edit param values to iCagenda v3
		if ($evtmaxRlistGlobal == '1') {
			$evtmaxRlistGlobal = '';
		}
		if ($evtmaxRlistGlobal == '0') {
			$evtmaxRlistGlobal = '2';
		}

		if ($evtmaxRlistGlobal == '2') {
			$maxRlist = $evtmaxRlist;
		} else {
			$maxRlist = $gmaxRlist;
		}
		return $maxRlist;
	}

	// function Max Registrations per event
	protected function maxReg ($i){
		$maxReg = '1000000';
//		if (isset($this->options['maxReg'])) {$maxRlist = $this->options['maxReg'];}

		$param = $this->evtParams($i);
		if ($param->get('maxReg')) {$maxReg = $param->get('maxReg');}

		return $maxReg;
	}

	// function Max Nb Tickets (Control if set)
	protected function maxNbTickets ($i){
		$maxNbTickets = '1000000';
//		if (isset($this->options['maxReg'])) {$maxRlist = $this->options['maxReg'];}

		$param = $this->evtParams($i);
		if ($param->get('maxReg')) {$maxNbTickets = $param->get('maxReg');}
		if (($maxNbTickets != '1000000') && ($this->statutReg($i) == '1')) {
			return $maxNbTickets;
		}
	}

	// function Number of places left
	protected function placeLeft ($i){
		$placeLeft = '';
		$maxReg = $this->maxReg($i);
		$registered = $this->registered($i);
		$placeLeft = ($maxReg - $registered);
		if (($maxReg != '1000000') && ($this->statutReg($i) == '1')) {
			return $placeLeft;
		}
	}

	// function Email Required
	protected function emailRequired ($i){
		$emailRequired = '';
		if (isset($this->options['emailRequired'])) { $emailRequired=$this->options['emailRequired']; } else { $emailRequired = '0'; }
		return $emailRequired;
	}

	// function Phone Required
	protected function phoneRequired ($i){
		$phoneRequired = '';
		if (isset($this->options['phoneRequired'])) { $phoneRequired=$this->options['phoneRequired']; } else { $phoneRequired = '0'; }
		return $phoneRequired;
	}

	// function pre-formated to display Register button and registered bubble
	protected function reg ($i){
		$toDay=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$h= date('H');
		$min= date('i');
		$toDay=mktime($h,$min,0,$m,$day,$y);
		$testDate = $this->mkt($i->next);

		$reg = $this->statutReg($i);
		$accessreg = $this->accessReg($i);
		$nbreg = $this->registered($i);
		$maxreg = $this->maxReg($i);
		$pastDates = $this->pastDates($i);

		// Initialize controls
		$access='0';
		$control='';

		// Access Control
		$user = JFactory::getUser();
		$userLevels = $user->getAuthorisedViewLevels();

// Removed in v3.0 and replaced with in_array

//		$access=$accessreg;
//		if ($access == '0') { $access='1'; }
//		foreach ($userLevels as $level){
//			if ($level == $access) {
//				$control=$access;
//			}
//		}

//echo $accessreg;
//print_r($userLevels);

//		if ($control == $access) {

		$TextRegBt = '';
		$param = $this->evtParams($i);

		if ($param->get('RegButtonText')) {
			$TextRegBt = $param->get('RegButtonText');
		} elseif (isset($this->options['RegButtonText'])) {
			$TextRegBt = $this->options['RegButtonText'];
		} else {
			$TextRegBt = JText::_( 'COM_ICAGENDA_REGISTRATION_REGISTER');
		}


		if ( in_array($accessreg, $userLevels) )  {
			if (($reg == 1) && ($pastDates == 1) && ($nbreg < $maxreg)) {
				return '<div class="regisBox"><a href="'.$this->regUrl($i).'"><div class="regis_button">'.$TextRegBt.'</div></a><a href="'.$this->regUrl($i).'"><div class="regis_imgbutton"></div></a><div class="icRegistered" >'.$this->registered($i).'</div></div>';
			}
			if (($reg==1) && ($pastDates == 1) && ($nbreg >= $maxreg)) {
				return '<div class="regisBox"><a><div class="regis_button">'.JText::_( 'COM_ICAGENDA_REGISTRATION_EVENT_FULL').'</div></a><div class="icRegistered" >'.$this->registered($i).'</div></div>';
			}
			if (($reg==1) && ($pastDates == 0)) {
				return '<div class="regisBox"><a><div class="event_finished">'.JText::_( 'COM_ICAGENDA_REGISTRATION_EVENT_FINISHED').'</div></a><div class="icRegistered" >'.$this->registered($i).'</div></div>';
			}
		} else {
			if (($reg == 1) && ($pastDates == 1) && ($nbreg < $maxreg)) {
				$accessInfo = 'alert( \''.JText::_( 'JERROR_ALERTNOAUTHOR' ).' \n\n '.JText::_( 'JGLOBAL_YOU_MUST_LOGIN_FIRST' ).'\' )';
				return '<div class="regisBox"><a href="#" onClick="'.$accessInfo.'"><div class="regis_button">'.$TextRegBt.'</div></a><a href="#" onClick="'.$accessInfo.'"><div class="regis_imgbutton"></div></a><div class="icRegistered" >'.$this->registered($i).'</div></div>';
			} else {
				return '';
			}
		}
	}


	// function to get number of registered people to an event
	protected function registered ($i){

		// Preparing connection to db
		$db	= $this->getDbo();
		// Preparing the query
		$query = $db->getQuery(true);
		$query->select(' sum(r.people) AS registered')->from('#__icagenda_registration AS r')->where('(r.eventId='.(int)$i->id.') AND (r.state > 0)');
		$db->setQuery($query);
		$people = $db->loadObjectList();

		$reg = $this->statutReg($i);
		$nbreg = $people[0]->registered;
		if ($reg==1) {

			if ($nbreg == NULL) {
				$nbreg = '0';
				return $nbreg;
			} else {
				return $nbreg;
			}
		}

	}

	// url to return event details after registration (changed in 2.1.14 not in use; see $urlist)
	protected function urlList ($i){
		// Preparing connection to db
		$db	= $this->getDbo();
		// Preparing the query
		$query = $db->getQuery(true);
		$query->select(' r.eventId AS idevt')->from('#__icagenda_registration AS r');
		$db->setQuery($query);
		$idevt = $db->loadObjectList();

		$link = $this->options['Itemid'];
		$urllist = JROUTE::_('index.php?option=com_icagenda&view=list&layout=event&id='.(int)$idevt.'&Itemid='.(int)$link);
		$url=$urllist;
		if (is_numeric($link) && !is_array($link)) {
			return $url;
		}
		else {
			$url = JROUTE::_('index.php');
			return $url;
		}
	}

	// Save of a registration, and automatic email
	public function registration ($array){
		$data =new stdClass();
		$idevent = $data->id;
		$data->id = null;
		if(isset($array['uid'])) $data->userid = $array['uid'];
		if(isset($array['name'])) $data->name = $array['name'];
		if(isset($array['email'])) $data->email = $array['email'];
		if(isset($array['phone'])) $data->phone = $array['phone'];
		if(isset($array['date'])) $data->date = $array['date'];
		if(isset($array['period'])) $data->period = $array['period'];
		if(isset($array['people'])) $data->people = $array['people'];
		if(isset($array['event'])) $data->eventid = $array['event'];
		if(isset($array['menuID'])) $data->itemid = $array['menuID'];
		$data->checked_out_time = date('Y-m-d H:i:s');

		$eventid = $data->eventid;
		if ($period != NULL) {$period = $data->period;} else {$period = '0';}
		$people = $data->people;
		$name = $data->name;
		$email = $data->email;
		$phone = $data->phone;
		$dateReg = $data->date;


		// Get the "event" URL
		$baseURL = JURI::base();
		$subpathURL = JURI::base(true);

// To be tested
//			$temp = str_replace('http://', '', $baseURL);
//			$temp = str_replace('https://', '', $temp);
//			$parts = explode($temp, '/', 2);
//			$subpathURL = count($parts) > 1 ? $parts[1] : '';


		$baseURL = str_replace('/administrator', '', $baseURL);
		$subpathURL = str_replace('/administrator', '', $subpathURL);

//		if(JFactory::getApplication()->isAdmin()) {
//			$urlevent = 'index.php?option=com_icagenda&view=list&layout=event&Itemid='.(int)$data->itemid.'&id='.(int)$data->eventid;
//		} else {
			$urlevent = str_replace('&amp;','&', JRoute::_('index.php?option=com_icagenda&view=list&layout=event&Itemid='.(int)$data->itemid.'&id='.(int)$data->eventid));
			$urllist = str_replace('&amp;','&', JRoute::_('index.php?option=com_icagenda&view=list&Itemid='.(int)$data->itemid));
//		}


		// Sub Path filtering
		$subpathURL = ltrim($subpathURL, '/');

		// URL Event Details filtering
		$urlevent = ltrim($urlevent, '/');
		if(substr($urlevent,0,strlen($subpathURL)+1) == "$subpathURL/") $urlevent = substr($urlevent,strlen($subpathURL)+1);
		$urlevent = rtrim($baseURL,'/').'/'.ltrim($urlevent,'/');

		// URL List filtering
		$urllist = ltrim($urllist, '/');
		if(substr($urllist,0,strlen($subpathURL)+1) == "$subpathURL/") $urllist = substr($urllist,strlen($subpathURL)+1);
		$urllist = rtrim($baseURL,'/').'/'.ltrim($urllist,'/');


		// Import params - Limit Options for User Registration
		$app = JFactory::getApplication();
		$icpar = $app->getParams();

		$limitRegEmail='1';
		$limitRegDate = '1';
		$emailRequired = '1';
		$limitRegEmail=$icpar->get('limitRegEmail');
		$limitRegDate=$icpar->get('limitRegDate');
		$emailRequired=$icpar->get('emailRequired');

		$alreadyexist='no';
		if (($limitRegEmail == 1) OR ($limitRegDate == 1)) {
			$db = JFactory::getDBO();
			$cf = JRequest::getString('email', '', 'post');

			if ($limitRegDate == 0) {
				$query = "
				  SELECT COUNT(*)
				    FROM `#__icagenda_registration`
				    WHERE `email` = '$cf' AND `eventid`='$eventid' AND `state`='1'
				";
			}
			if ($limitRegDate == 1) {
				$query = "
				  SELECT COUNT(*)
				    FROM `#__icagenda_registration`
				    WHERE `email` = '$cf' AND `eventid`='$eventid' AND `date`='$dateReg' AND `state`='1'
				";
			}

			$db->setQuery($query);
			if ( $db->loadResult() ) {
				$alreadyexist='yes';
				JError::raiseWarning( 100, JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_ALERT' ).' '.$email.'<br>' );
//			JFactory::getApplication()->enqueueMessage('This email has already been registered.');
//      $mainframe =& JFactory::getApplication();
//      $mainframe->enqueuemessage('This account has already been registered.');

			//get the application object
			$app = JFactory::getApplication();
			//redirect to the event page
			$app->redirect(htmlspecialchars_decode($urlevent));
				return false;
			} else {
				$alreadyexist='no';
			}
		}


		if ($email == '') {
			$email=JText::_( 'COM_ICAGENDA_NOT_SPECIFIED' );
		}
		if ($phone == '') {
			$phone=JText::_( 'COM_ICAGENDA_NOT_SPECIFIED' );
		}
		// Insert data of the registered user (Option Email required)
		if ($emailRequired == '1') {
			if (is_numeric($eventid) && is_numeric($period) && is_numeric($people) && ($name != NULL) && ($email != NULL)) {
				$db = JFactory::getDBO();
				$db->insertObject( '#__icagenda_registration', $data, id );
			}
		} else {
			if (is_numeric($eventid) && is_numeric($period) && is_numeric($people) && ($name != NULL)) {
				$db = JFactory::getDBO();
				$db->insertObject( '#__icagenda_registration', $data, id );
			}
		}

//		if (is_numeric($eventid) && is_numeric($period) && is_numeric($people) && ($name != NULL) && ($email != NULL)) {
//			$db = JFactory::getDBO();
//			$db->insertObject( '#__icagenda_registration', $data, id );
//		}

		// Preparing connection to db
		$db	= $this->getDbo();

		// Preparing the query
		$query = $db->getQuery(true);
		$query->select('e.title AS title, e.startdate AS startdate, e.enddate AS enddate, e.created_by AS author')->from('#__icagenda_events AS e')->where("(e.id=$data->eventid)");
		$db->setQuery($query);
		$title=$db->loadObject()->title;
		$startdate=$db->loadObject()->startdate;
		$enddate=$db->loadObject()->enddate;
		$author=$db->loadObject()->author;

		$starDate = strftime("%d/%m/%Y", strtotime("$startdate"));
		$startD = JText::_($starDate);

		$endDate = strftime("%d/%m/%Y", strtotime("$enddate"));
		$endD = JText::_($endDate);

		$starTime = strftime("%H:%M", strtotime("$startdate"));
		$startT = JText::_($starTime);

		$endTime = strftime("%H:%M", strtotime("$enddate"));
		$endT = JText::_($endTime);

		$periodreg = $data->period;

		// Import params
		$app = JFactory::getApplication();
		$icpar = $app->getParams();

		$defaultemail='';
		$emailUserSubjectPeriod='';
		$emailUserBodyPeriod='';
		$emailUserSubjectDate='';
		$emailUserBodyDate='';
		$defaultemail=$icpar->get('regEmailUser');
		$emailUserSubjectPeriod=$icpar->get('emailUserSubjectPeriod');
		$emailUserBodyPeriod=$icpar->get('emailUserBodyPeriod');
		$emailUserSubjectDate=$icpar->get('emailUserSubjectDate');
		$emailUserBodyDate=$icpar->get('emailUserBodyDate');



		if (isset($emailUserSubjectPeriod)){
			$eUSP=$emailUserSubjectPeriod;
		} else {
			$eUSP=JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_USER_PERIOD_DEFAULT_SUBJECT' );
		}

		if (isset($emailUserBodyPeriod)){
			$eUBP=$emailUserBodyPeriod;
		} else {
			$eUBP=JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_USER_PERIOD_DEFAULT_BODY' );
		}

		if (isset($emailUserSubjectDate)){
			$eUSD=$emailUserSubjectDate;
		} else {
			$eUSD=JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_USER_DATE_DEFAULT_SUBJECT' );
		}

		if (isset($emailUserBodyDate)){
			$eUBD=$emailUserBodyDate;
		} else {
			$eUBD=JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_USER_DATE_DEFAULT_BODY' );
		}

		if ($periodreg == 1) {
			$periodd = JText::sprintf( 'COM_ICAGENDA_REGISTERED_EVENT_PERIOD', $startD, $startT, $endD, $endT );
			$adminsubject = JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_ADMIN_DEFAULT_SUBJECT' );
			$adminbody = JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_ADMIN_PERIOD_DEFAULT_BODY' );
			if ($defaultemail == 0) {
				$subject = $eUSP;
				$body = $eUBP;
			} else {
				$subject = JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_USER_PERIOD_DEFAULT_SUBJECT' );
				$body = JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_USER_PERIOD_DEFAULT_BODY' );
			}
		} else {
			$periodd = JText::sprintf( 'COM_ICAGENDA_REGISTERED_EVENT_DATE', $array['date'], '' );
			$adminsubject = JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_ADMIN_DEFAULT_SUBJECT' );
			$adminbody = JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_ADMIN_DATE_DEFAULT_BODY' );
			if ($defaultemail == 0) {
				$subject = $eUSD;
				$body = $eUBD;
			} else {
				$subject = JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_USER_DATE_DEFAULT_SUBJECT' );
				$body = JText::_( 'COM_ICAGENDA_REGISTRATION_EMAIL_USER_DATE_DEFAULT_BODY' );
			}
		}

		// Get the site name
		$config = JFactory::getConfig();
		if(version_compare(JVERSION, '3.0', 'ge')) {
			$sitename = $config->get('sitename');
		} else {
			$sitename = $config->getValue('config.sitename');
		}



//		$siteURL = JURI::base();
//		$siteURL = rtrim($siteURL,'/');
		// ROUTE
//		$urlevent = str_replace('&amp;','&', JROUTE::_('index.php?option=com_icagenda&view=list&layout=event&id='.(int)$data->eventid));

		// Preparing connection to db
		$db	= $this->getDbo();
		// Preparing the query
		$query = $db->getQuery(true);
		$query->select('email AS authormail, name AS author')->from('#__users AS u')->where("(u.id=$author)");
		$db->setQuery($query);
		$authormail=$db->loadObject()->authormail;
		$author=$db->loadObject()->author;

		if ($authormail == NULL) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				$authormail = $config->get('mailfrom');
			} else {
				$authormail = $config->getValue('config.mailfrom');
			}
		}

		// MAIL
		$replacements = array(
			"\\n"				=> "\n",
			'[SITENAME]'		=> $sitename,
			'[SITEURL]'			=> $siteURL,
			'[AUTHOR]'			=> $author,
			'[AUTHOREMAIL]'		=> $authormail,
			'[TITLE]'			=> $title,
//			'[EVENTURL]'		=> $siteURL.$urlevent,
			'[EVENTURL]'		=> $urlevent,
			'[NAME]'			=> $name,
			'[EMAIL]'			=> $email,
			'[PHONE]'			=> $phone,
			'[PLACES]'			=> $people,
			'[DATETIME]'		=> $data->date,
			'[STARTDATE]'		=> $startD,
			'[ENDDATE]'			=> $endD,
			'[STARTDATETIME]'	=> $startD.' - '.$startT,
			'[ENDDATETIME]'		=> $endD.' - '.$endT,
		);


		foreach($replacements as $key => $value) {
			$subject = str_replace($key, $value, $subject);
			$body = str_replace($key, $value, $body);
			$adminsubject = str_replace($key, $value, $adminsubject);
			$adminbody = str_replace($key, $value, $adminbody);
		}

		$mailer = JFactory::getMailer();
		$adminmailer = JFactory::getMailer();
//		$config = JFactory::getConfig();
		if(version_compare(JVERSION, '3.0', 'ge')) {
			$mailfrom = $config->get('mailfrom');
			$fromname = $config->get('fromname');
		} else {
			$mailfrom = $config->getValue('config.mailfrom');
			$fromname = $config->getValue('config.fromname');
		}
		$mailer->setSender(array( $mailfrom, $fromname ));
		$adminmailer->setSender(array( $mailfrom, $fromname ));

		$user = JFactory::getUser();
		if (isset($user->email)) {
			$recipient = $user->email;
		} else {
			$recipient = $data->email;
		}
//		$adminrecipient = $mailfrom;

		$mailer->addRecipient($recipient);

		$adminrecipient = array($mailfrom, $authormail);
		$adminmailer->addRecipient($adminrecipient);

		$mailer->setSubject($subject);
		$adminmailer->setSubject($adminsubject);
		$mailer->setBody($body);
		$adminmailer->setBody($adminbody);
		// Optional file attached
//		$mailer->addAttachment(JPATH_COMPONENT.DS.'assets'.DS.'document.pdf');

		if (isset($user->email)) {
			$send = $mailer->Send();
		}
/* Removed in 3.0
		if ( $send !== true ) {
		    echo 'Error sending email: ' . $send->message;
		} else {
		    echo 'Mail sent';
		}
*/

		$sendadmin = $adminmailer->Send();
/* Removed in 3.0
		if ( $sendadmin !== true ) {
		    echo 'Error sending email: ' . $sendadmin->message;
		} else {
		    echo 'Mail sent';
		}
*/


		if ($alreadyexist == 'no') {
			// get the application object
			$app = JFactory::getApplication();

			// redirect after successful registration
			$app->redirect(htmlspecialchars_decode($urllist) , ''. JText::_( 'COM_ICAGENDA_REGISTRATION_TY' ).' '.$data->name.', '.JText::sprintf( 'COM_ICAGENDA_REGISTRATION', $title ).'<br>'.$periodd.' (<a href="'.$urlevent.'">'. JText::_( 'COM_ICAGENDA_REGISTRATION_EVENT_LINK' ).'</a>)');
		}

	}


	/**
	 * ESSENTIAL FUNCTIONS
	 */

	// FUNCTION TO CHECK IF NEXT MOVE
	protected function ctrlNext ($i){

/* Remove in 2.0
		$toDay=time();
		$nextMkt=$this->mkt($i->next);
		$exora=explode(':', $i->time);
		$next= JRequest::getVar('next');
		if ($next>$toDay){
			$ctrl=0;
		}elseif($next==$toDay){
			$ctrl=0;
		}else{
			$ctrl=1;
		}
		if($ctrl==0){
			return $i;
		}else{
			$days=unserialize($i->dates);
			foreach($days as $d){
				$dMkt=$this->mkt($d);
				// si date passée + date aujourd'hui
				if ($dMkt<$toDay){
					$i->next=$d;
					return $i;
				}
				//si date passée + date future
				else{
					return $i;
				}
			}
			$this->writeNext($i);
			return $i;
		}
end remove */

		return $i;

	}

	// mktime with control
	private function mkt($data)
	{
		$data=str_replace(' ', '-', $data);
		$data=str_replace(':', '-', $data);
		$ex_data=explode('-', $data);
		if (isset($ex_data['3']))$hour=$ex_data['3'];
		if (isset($ex_data['4']))$min=$ex_data['4'];
		if ((isset($hour)) && (isset($min)) && ($hour!='') && ($hour!=NULL) && ($min!='') && ($min!=NULL)) {
			$ris=mktime($ex_data['3'], $ex_data['4'], '00', $ex_data['1'], $ex_data['2'], $ex_data['0']);
		} else {
			$ris=mktime('00', '00', '00', $ex_data['1'], $ex_data['2'], $ex_data['0']);
		}
		return strftime($ris);
	}

	// mktime with time
	private function mkttime($data)
	{
		$data=str_replace(' ', '-', $data);
		$data=str_replace(':', '-', $data);
		$ex_data=explode('-', $data);
		$ris=mktime($ex_data['3'], $ex_data['4'], '00', $ex_data['1'], $ex_data['2'], $ex_data['0']);
		return strftime($ris);
	}

	// mktime with only date
	private function mktshort($data)
	{
		$data=str_replace(' ', '-', $data);
		$data=str_replace(':', '-', $data);
		$ex_data=explode('-', $data);
		$ris=mktime('00', '00', '00', $ex_data['1'], $ex_data['2'], $ex_data['0']);
		return strftime($ris);
	}

	// Function to convert font color, depending on category color
	function fontColor($i){
		$RGB='$RGB';
		$RGBa=$RGB[0];
		$RGBb=$RGB[1];
		$RGBc=$RGB[2];

		// Preparing connection to db
		$db	= $this->getDbo();
		// Preparing the query
		$query = $db->getQuery(true);
		$query->select('c.color AS cat_color')->from('#__icagenda_category AS c')->where("(c.id=$i->catid)");
		$db->setQuery($query);
		$col=$db->loadObject()->cat_color;

		$color = '';
		if (isset($col)) {$color = $col;}

//		if(!is_array($color) && preg_match("/^[#]([0-9a-fA-F]{6})$/",$color)){

			$hex_R = substr($color,1,2);
			$hex_G = substr($color,3,2);
			$hex_B = substr($color,5,2);
			$RGBhex = hexdec($hex_R).",".hexdec($hex_G).",".hexdec($hex_B);
//		}
		$RGB = explode(",",$RGBhex);
		$RGBa=$RGB[0];
		$RGBb=$RGB[1];
		$RGBc=$RGB[2];
//		$a = array($RGBa, $RGBb, $RGBc);
//		$somme = array_sum($a);
		$somme = ($RGBa + $RGBb + $RGBc);
		if ($somme > '600') {
			$fcolor = 'fontColor';
		} else {
			$fcolor = '';
		}
		return $fcolor;
	}
}


//	protected function gcalendarUrl ($i){
//		$ora=$i->time;
//		if($ora==0)$ora='00.00';
//		$text=$i->title.' ('.$i->cat_title.')';
//		$details=$this->descShort($i);
//		$place=$i->place.', '.$i->address;
//		$link=$this->url($i);
//
//		$date= JRequest::getVar('date');
//
//		$dates=str_replace('-', '', $date).'T'.str_replace('.', '', $ora).'00/'.str_replace('-', '', $date).'T'.str_replace('.', '', $ora).'00';
//		$href="http://www.google.com/calendar/event?action=TEMPLATE
//			&text=".urlencode($text)."
//			&dates=".$dates."
//			&place=".urlencode($place)."
//			&details=".urlencode($details)."
//			&sprop=sito web:".urlencode($link);
//
//		return $href;
//	}
//
//	protected function gcalendarLink ($i){
//		return '<a href="'.$this->gcalendarUrl($i).'">Gcalendar</a>';
//	}


?>
